Net::Frame::Layer::ARP(3)

NAME
Net::Frame::Layer::ARP - Address Resolution Protocol layer object

SYNOPSIS
   use Net::Frame::Layer::ARP qw(:consts);

   # Build a layer
   my $layer = Net::Frame::Layer::ARP->new(
      hType   => NF_ARP_HTYPE_ETH,
      pType   => NF_ARP_PTYPE_IPv4,
      hSize   => NF_ARP_HSIZE_ETH,
      pSize   => NF_ARP_PSIZE_IPv4,
      opCode  => NF_ARP_OPCODE_REQUEST,
      src     => '00:00:00:00:00:00',
      dst     => NF_ARP_ADDR_BROADCAST,
      srcIp   => '127.0.0.1',
      dstIp   => '127.0.0.1',
   );
   $layer->pack;

   print 'RAW: '.$layer->dump."\n";

   # Read a raw layer
   my $layer = Net::Frame::Layer::ARP->new(raw => $raw);

   print $layer->print."\n";
   print 'PAYLOAD: '.unpack('H*', $layer->payload)."\n"
      if $layer->payload;

DESCRIPTION
This modules implements the encoding and decoding of the ARP layer.

RFC: ftp://ftp.rfc-editor.org/in-notes/rfc826.txt

See also Net::Frame::Layer for other attributes and methods.

ATTRIBUTES

hType
pType
    Hardware and protocol address types.

hSize
pSize
    Hardware and protocol address sizes in bytes.

opCode
    The operation code number to perform.

src
dst Source and destination hardware addresses.

srcIp
dstIp
    Source and destination IP addresses.

The following are inherited attributes. See Net::Frame::Layer for more information.

raw
payload
nextLayer

METHODS

new
new (hash)
    Object constructor. You can pass attributes that will overwrite default ones. See SYNOPSIS for default values.

getKey
getKeyReverse
    These two methods are basically used to increase the speed when using recv method from Net::Frame::Simple. Usually, you write them when you need to write match method.

match (Net::Frame::Layer::ARP object)
    This method is mostly used internally. You pass a Net::Frame::Layer::ARP layer as a parameter, and it returns true if this is a response corresponding for the request, or returns false if not.

The following are inherited methods. Some of them may be overridden in this layer, and some others may not be meaningful in this layer. See Net::Frame::Layer for more information.

layer
computeLengths
computeChecksums
pack
unpack
encapsulate
getLength
getPayloadLength
print
dump

CONSTANTS
Load them: use Net::Frame::Layer::ARP qw(:consts);

NF_ARP_HTYPE_ETH
    Hardware address types.

NF_ARP_PTYPE_IPv4
NF_ARP_PTYPE_IPv6
    Protocol address types.

NF_ARP_HSIZE_ETH
    Hardware address sizes.

NF_ARP_PSIZE_IPv4
NF_ARP_PSIZE_IPv6
    Protocol address sizes.

NF_ARP_OPCODE_REQUEST
NF_ARP_OPCODE_REPLY
    Operation code numbers.

NF_ARP_ADDR_BROADCAST
    Broadcast address for src or dst attributes.

SEE ALSO
Net::Frame::Layer

AUTHOR
Patrice <GomoR> Auffret

COPYRIGHT AND LICENSE
Copyright (c) 2006-2019, Patrice <GomoR> Auffret

You may distribute this module under the terms of the Artistic license. See LICENSE.Artistic file in the source distribution archive.